#include <cthreads.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

int counter = 0;
mutex_t mutex;

int numbers [] = {0, 1, 2, 3, 4, 5, 6, 7, 8};

any_t threads_more (any_t amount) {
  int i;
  
  for (i = 0; i < *(int*)amount; i++)
      cthread_fork (threads_more, &numbers[i]);

  mutex_lock (mutex);
  counter ++;
  mutex_unlock (mutex);
  return NULL;
}

int main () {
  cthread_init ();
  mutex = mutex_alloc ();
  cthread_fork (threads_more, &numbers[8]);
  sleep (15);
  printf ("After 15 seconds, there were %i threads\n", counter);  
  return 0;
}
