#include <cthreads.h>
#include <stdio.h>
#include <stdlib.h>

any_t advanced_math (any_t number) {
  double d, *dp;

  d = *(double*)number;
  while (d>0)
      d -= 3.14159;

  dp = malloc (sizeof(double));
  *dp = d;
  return dp;
}

int main () {
  cthread_t t1, t2;
  double d1 = 5000, d2 = 8000;
  double r1, r2;

  cthread_init ();
  t1 = cthread_fork (advanced_math, &d1);
  t2 = cthread_fork (advanced_math, &d2);
  r1 = *(double*)cthread_join (t1);
  r2 = *(double*)cthread_join (t2);
  printf ("Advanced math gave result of %e\n", r1*r2);
  
  return 0;
}
